#include <stdio.h>
#include <stdlib.h>

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#define DELTA 0.1
#define DELTA_MIN (1.0 - DELTA)
#define DELTA_MAX (1.0 + DELTA)

#ifndef VDELTA
#define VDELTA 0.08
#endif


/* verify if V equals target */
int Veql( float V, float target)
{
  if( V > (target-VDELTA)  && V < (target+VDELTA))
    return TRUE;
  else 
    return FALSE;
}
  

int main(int argc, char *argv) {
  int ret, i, c1, c2; /* channels 1 + 2 */
  int c3, c4;
  float t, V, Vc, C; /* time, voltage, voltage for current, current */
  float Vm, Vmc, Cm; /* Voltage/Current readings for memory */ 
  int start = TRUE;
  int c1min, c2min, c1max, c2max;
  int c3min, c4min, c3max, c4max;
  int n; /* number of data items averaged */
  int p; /* number of data items averaged */
  float tmin, tmax, Vsum, Vcsum, Csum, Vavg, Psum = 0.0;
  float Vmsum, Vmcsum, Cmsum, Vmavg, Pmsum = 0.0;
  float startT=0;

  int headPast=FALSE;

  while (TRUE) {
    ret = scanf("%f %d %f %d %f %f %d %f %d %f %f\n", &t, &c1, &V, &c2, &Vc, &C, &c3, &Vm, &c4, &Vmc, &Cm);

    if (ret <= 0){
     
      break;
      }  

#if 0
    if( !headPast &&  Veql(V,1.5) ){
      headPast=TRUE;
      continue;
    }
    
    if( !headPast && !Veql(V,1.5)){
      printf("Error: no head\n");
      exit(-1);
    }

    if( headPast && !Veql(V,1.5)){
#endif

    if (1) {   
      if (start ||
	  !((Vavg = Vsum/n) && Vavg*DELTA_MIN <= V && V <= Vavg*DELTA_MAX)) {
	if(start){
          p = 1;
	  startT=t;
	}
	if (!start) {
	  printf("%f %d %f %d %f %f %f %f\n", tmin, c1min, Vavg, c2min, Vcsum/n, Csum/n, Vavg*(Csum/n));
	  if (tmin != tmax)
	    printf("%f %d %f %d %f %f %f\n", tmax, c1max, Vavg, c2max, Vcsum/n, Csum/n, Vavg*(Csum/n));
	  Psum += Vavg * Csum;
//	  Pmsum += Vmavg * Cmsum;
	}
	n = 1;
	tmin = tmax = t;
	c1min = c1;
	c2min = c2;
	Vsum = V;
	Vcsum = Vc;
	Csum = C;
/*
	c3min = c3;
	c4min = c4;
	Vmsum = Vm;
	Vmcsum = Vmc;
	Cmsum = Cm;*/
	start = FALSE;
      } else {
	n++;
	tmax = t;
	Vsum += V;
	Vcsum += Vc;
	Csum += C;      

        p++;
	Vmsum += Vm;
	Vmcsum += Vmc;
	Cmsum += Cm;      
      }
      c1max = c1;
      c2max = c2;
      c3max = c3;
      c4max = c4;
      
    }
    
  } 

  Vavg = Vsum/n;
  Vmavg = Vmsum/p;

  if (tmin != tmax)
    printf("%f %d %f %d %f %f %f\n", tmax, c1max, Vavg, c2max, Vcsum/n, Csum/n, Vavg*(Csum/n));
  Psum += Vavg * Csum;
  Pmsum += Vmavg * Cmsum;

  fprintf(stderr, "Power %f mWatt over %f secs = Energy %f mWatt-hours\n",
	  Psum, (tmax-startT), Psum / (3600.0 / (tmax-startT)));

  fprintf(stderr, "Power %f mWatt over %f secs = Energy %f mWatt-hours\n",
	  Pmsum, (tmax-startT), Pmsum / (3600.0 / (tmax-startT)));
}
