/********************************************************
 405lp user-level threads library with DVS support.

 TODO: mutex implementation is still not perfect.
       add padding to remove unnecessary Tbs.
       
       
*************************************************************/

#include <signal.h>
#include <setjmp.h>
#include <malloc.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <sys/time.h>
#include <math.h>
#include <stdarg.h>
#include <pthread.h>
#include <values.h>
#include "my_threads.h"



/*Note: 
  1. If the following FREQ_POINTS table is changed, need to change
  the function alpha2freq().
  2. If the frequency level does not follow the order of 33,44,66,133,266, 
  need to change ASYN my_set_freq() in dpm405lp.c.  
*/
#if NUM_FREQ==5
char* FREQ_POINTS[NUM_FREQ*2] = { "33/33/16", "44/44/16", "66/66/16", "133/133/16", "266/133/16",
                                  "66/33/16", "133/66/16", "133/33/16", "266/66/16", "266/33/16" };
int Frequencies[NUM_FREQ*2] = { 33,44, 66, 133, 266, 66, 133, 133, 266, 266};
#endif

#if NUM_FREQ==3
char* FREQ_POINTS[NUM_FREQ] = {"33/33/16", "44/44/16", "66/66/16"};
int Frequencies[NUM_FREQ] = {  33, 44, 66};
#endif

#if NUM_FREQ==4
char* FREQ_POINTS[NUM_FREQ] = {"33/33/16", "44/44/16", "66/66/16", "133/133/16"};
int Frequencies[NUM_FREQ] = {  33, 44, 66, 133};
#endif


/*-- only one of the following two macros should be defined --*/
//#define SIMPLE_FEEDBACK 1
#define PID_FEEDBACK 1


int currentFreqIndex;
int largestDeadline;

long_t schd_overhead=0;
long_t schd_num=0;


static struct avgErrType avgErr;

extern long_t  hyperP;

int* sortedQ;


int DVS =0 ;


#define AGR_K 0.9

int opt_avg_freq;

/* The thread "queue" */
static thread threadList[ MAX_THREADS ];

static bool release_vector [MAX_THREADS];

/*  The index of the currently executing thread */
static int currentThread = -2;
static int tmpCurrentThread=-2;

/* The number of active threads */
static int numThreads = 0;

/* start time */
struct timeval StartTime, CurrentTime;
struct timeval PrintTime;
long_t  StartTime_usec, CurrentTime_usec, Timer_usec, PrintTime_usec;
struct itimerval itimer;
struct itimerval oldTimer;
struct timeval ovt1, ovt2;

struct itimerval current_alarm;
//long_t  current_alarm_usec;

double system_U = 0;

double new_system_U = 0;

void dvs_fd(long_t );
void dvs_org_fd(long_t );

static void timerhandler (void);
int fixedFreq=MAX_FREQ_INDEX;

static unsigned int loadType;

pthread_mutex_t mutex_sched = PTHREAD_MUTEX_INITIALIZER;
int in_sched=FALSE;

int canon_freq;

long_t  tb2nextRel=0;




a_Q * alphaQ=NULL;

long_t  last_event_time;


long_t getGCD( long_t  n1, long_t n2)
{
  if (n2==0)
    return n1;
  else
    return ( getGCD(n2, n1 % n2));
}



inline float max(float a, float b) {
  if (a > b) return a;
  else return b;
}

inline float min(float a, float b){
  if( a>b) return b;
  else return a;
}



void initAlphaQ(a_Q ** head)
{
  *head=NULL;
  return;
}


  /* insert a new task item into alpha Q in EDF* order */
void push2AlphaQ(a_Q ** head, int id, long_t  r, long_t  d, long_t  rem )
{
  a_Q * pNew; 

  a_Q * ptr= *head;

  mytrace("enter push2Alpha\n");
  pNew=(a_Q *)malloc(sizeof(a_Q));
  pNew->id=id;
  pNew->r=r;
  pNew->d=d;
  pNew->rem=rem;
  /* insert aPtr into alpha Q in EDF* order */

  if(ptr==NULL){
    /* empty alpha Q */
    (*head)=pNew;
    pNew->next=NULL;
  }else if(ptr->next==NULL){
    /* alpha Q has only one elment */
    if(ptr->d > pNew->d || ( ptr->d==pNew->d && ptr->r>pNew->r ) 
       || (ptr->d==pNew->d && ptr->r==pNew->r && ptr->id > pNew->id) ){
      *head=pNew;
      pNew->next= ptr;
    }else{
      ptr->next=pNew;
      pNew->next=NULL;
    }
    
  }/* end of one elment alpha Q case */
  else {
    /* alpha Q has more than one elment */
    if(ptr->d> pNew->d || ( ptr->d==pNew->d && ptr->r>pNew->r ) 
       || (ptr->d==pNew->d && ptr->r==pNew->r && ptr->id > pNew->id) ){
      *head=pNew;
      pNew->next= ptr;
    }else{
      while(ptr->next!=NULL && ( (ptr->next->d < pNew->d)
				 ||(ptr->next->d==pNew->d && ptr->next->r<pNew->r) 
				 ||(ptr->next->d==pNew->d && ptr->next->r==pNew->r && ptr->next->id<pNew->id )) ){
	ptr=ptr->next;
      }
      
      if(ptr->next==NULL){
	ptr->next=pNew;
	pNew->next=NULL;
      }else{
	pNew->next=ptr->next;
	ptr->next=pNew;
      }
    }

  }/* end of more than one elment alpha Q case */

}



void dumpAlphaQ(a_Q **head)
{
  a_Q * ptr;
  ptr=*head;

  mytrace("dumpAlphaQ\n");
  while (ptr!=NULL){
    mytrace("dump {T%d,r=%lld,d=%lld,rem=%lld}\n",ptr->id,ptr->r-StartTime_usec,ptr->d-StartTime_usec,ptr->rem);
    ptr=ptr->next;
  }
  mytrace("\n");
}


/*  update the rem field of the alpha Q head*/
void updateAlphaQ(a_Q **head, long_t  elapsedTime)
{
  a_Q *pHead= *head;

  //mytrace("Enter update alphaQ, elapsedTime=%lld\n", elapsedTime);
  if( pHead==NULL ){
    printf("update alphpaQ: pHead==NULL\n");
    return;
  }
  
  while(pHead!=NULL && pHead->rem <= elapsedTime){
    //mytrace("alphaQ head->rem=%lld, elapsedTime=%lld\n", pHead->rem, elapsedTime);
    elapsedTime -=pHead->rem;
    *head=pHead->next;
    free(pHead);
    //mytrace(" alpha Q head removed\n");
    pHead=*head;
  }
  if(pHead!=NULL){
    pHead->rem-=elapsedTime;
  }

  //dumpAlphaQ(&alphaQ);
  //mytrace("end of updateAlphaQ\n");

}

/**********************************/


/*--
 * map alpha into the neareast high freq.
 --*/
int alpha2freq( double alpha)
{

  if(NUM_FREQ==3){
    if( 44.0/266.0 < alpha ) return 2;
    else if( 33.0/266.0 < alpha ) return 1;
    else return 0;
  }    
  else if (NUM_FREQ==4){
    if( 66.0/266.0 < alpha ) return 3;
    else if( 44.0/266.0 < alpha ) return 2;
    else if( 33.0/266.0 < alpha ) return 1;
    else return 0;
  }
  else if (NUM_FREQ==5){
    if( 133.0/266.0 < alpha ) {
      if (loadType == 0)
        return 9;
      else if (loadType == 2)
        return 8;
      else 
        return 4;
    }
    else if( 66.0/266.0 < alpha ) {
      if (loadType == 0)
        return 7;
      else if (loadType == 2)
        return 6;
      else 
        return 3;
    }
    else if( 44.0/266.0 < alpha ) {
      if ((loadType == 0) || (loadType == 2))
        return 5;
      else 
        return 2;
    }
    else if( 33.0/266.0 < alpha ) return 1;
    else return 0;
  }else if (NUM_FREQ==7){
    if( 200.0/266.0 < alpha ) return 6;
    else if( 166.0/266.0 < alpha ) return 5;
    else if( 133.0/266.0 < alpha ) return 4;
    else if( 100.0/266.0 < alpha ) return 3;
    else if( 66.0/266.0 < alpha ) return 2;
    else if( 50.0/266.0 < alpha ) return 1;
    else return 0;
  }

}

void static_dvs( int i) 
{
 
#ifdef SYNC

  my_set_freq(FREQ_POINTS[i]);
#else
  my_set_freq(i);
#endif

  currentFreqIndex = i;

}


void setCanSpeed(void)
{
  int i,j;

  i=alpha2freq(system_U);    
  for(j=0;j< numThreads-1; j++) {
    threadList[j].canon_freq=Frequencies[i];
  }
  canon_freq=Frequencies[i];
  opt_avg_freq=alpha2freq(0.5);
  mytrace("AGR: set can speed=System U: %f\n",system_U);
  static_dvs(i);

}


/**********************************/
/* Ravi 04/20/2004 */
/* cycle-conserving EDF DVS */
/**********************************/

void dvs_cc(int complete, unsigned int thread) {

  int i;

#ifdef CC_TEST
  printf("cc get ovt1\n");
  gettimeofday(&ovt1, NULL);
#endif

  mytrace("in cc_dvs %d %lf\n", complete,(double)threadList[thread].exec_cycles); 

  if (complete)
    {
      mytrace("in cc_dvs System_U: %lf diff:%lf\n", system_U, (double)((double) threadList[thread].exec_cycles - (double) threadList[thread].WCEC)); 
      threadList[thread].U_cc =  (double)((double) threadList[thread].exec_cycles /(double) (threadList[thread].period*Frequencies[NUM_FREQ-1]));
    }
  else
    {
      for (i=0; i< numThreads-1; i++)
	{
	  if (release_vector[i])
	    {
	      threadList[i].U_cc = (double) threadList[i].WCET / (double) threadList[i].period;
	    }
	}
    }

  mytrace("in cc_dvs %d System U:%lf\n",currentFreqIndex,system_U); 
  system_U = 0;
  for (i=0; i< numThreads-1; i++)
    system_U += threadList[i].U_cc;

  i = currentFreqIndex;

  //currentFreqIndex = ceil((system_U*(double)Frequencies[NUM_FREQ-1])/(double)Frequencies[0]) -1 ;
  currentFreqIndex=alpha2freq(system_U);


  mytrace("in cc_dvs %d System U:%lf\n",currentFreqIndex,system_U);

#ifdef CC_TEST
  gettimeofday( &ovt2,NULL);
  printf("cc overhead=%ld\n",ovt2.tv_sec*1000000+ovt2.tv_usec-ovt1.tv_sec*1000000-ovt1.tv_usec);
#endif

  if (i != currentFreqIndex) {
   
#ifdef SYNC
    my_set_freq(FREQ_POINTS[currentFreqIndex]);
#else
    my_set_freq(currentFreqIndex);
#endif


  }
}



void dvs_la(void ) {


  int i,j;
  double s, x;
  long_t  cleft;
  int temp;
  int sorted[NUM_THREADS];
  long_t  Dn;
  system_U = 0.0;
  s = 0.0;

#ifdef LA_TEST
  printf("la get ovt1\n");
  gettimeofday(&ovt1, NULL);
#endif

  for (j = 0; j < numThreads-1; j++) {
    system_U += threadList[j].U_la;
  }

  mytrace("in la_dvs %d System U:%f\n",currentFreqIndex,system_U); 


  for (j = 0; j < numThreads-1; j++) sorted[j] = j;
  for (i = 0; i < numThreads-1; i++) {
    for (j = i+1; j < numThreads-1; j++) {
      if (threadList[sorted[i]].abs_deadline < threadList[sorted[j]].abs_deadline) {
	temp = sorted[i];
	sorted[i]= sorted[j];
	sorted[j] = temp;
      }
    }
  }

  Dn = threadList[sorted[numThreads-2]].abs_deadline;
  mytrace("in la_dvs task:%d Dn:%lf\n",sorted[numThreads-2],(double)Dn); 

  for (i = 0 ; i < numThreads-1; i++) {
    system_U = system_U - threadList[sorted[i]].U_la;
    cleft = threadList[sorted[i]].WCEC - threadList[sorted[i]].exec_cycles;
    
    /*    
    if(cleft<=0 && DVS==DVS_ORG_LA)
      cleft=threadList[sorted[i]].WCEC;
    */

#ifdef DETAILED_LOGGING
    mytrace("in la_dvs WCEC:%lf exec_cycles:%lf\n",(double)threadList[sorted[i]].WCEC,(double)threadList[sorted[i]].exec_cycles); 
    mytrace("in la_dvs Di:%lf\n",(double)threadList[sorted[i]].abs_deadline,0); 
    mytrace("in la_dvs task:%d cleft:%lf\n",i,(double)cleft); 
    mytrace("in la_dvs 1-u: %lf, time:%lf\n",(1-system_U),(double)threadList[sorted[i]].abs_deadline - (double)Dn); 
#endif
    x = max((double)0, (double)(cleft - (1-system_U)*(((double)threadList[sorted[i]].abs_deadline - (double)Dn)*Frequencies[NUM_FREQ-1])));

    if(threadList[sorted[i]].abs_deadline!= Dn)
      system_U = system_U+(double)((double)((double)((double)cleft-x))/(double)((((double)threadList[sorted[i]].abs_deadline - (double)Dn)*Frequencies[NUM_FREQ-1])));
    s = s+x;
     
  }
  mytrace("in la_dvs s:%lf System U:%lf\n",s,system_U);

  gettimeofday(&CurrentTime, NULL);
  CurrentTime_usec = (long_t )CurrentTime.tv_usec + (long_t )1000000*(long_t )CurrentTime.tv_sec;
  system_U = s/((double)((double)((Dn - CurrentTime_usec))*Frequencies[NUM_FREQ-1]));
#ifdef DETAILED_LOGGING
  mytrace("in la_dvs Dn:%lf\n",(double)Dn,0); 
  mytrace("in la_dvs CurrentTime:%lf\n",(double)CurrentTime_usec,0); 
  mytrace("in la_dvs s:%lf Time:%lf\n",s,(double)((double)Dn - (double)CurrentTime_usec)); 
#endif
  i = currentFreqIndex;
  //currentFreqIndex = ceil((system_U*(double)Frequencies[NUM_FREQ-1])/(double)Frequencies[0]) -1 ;  
  //if (currentFreqIndex > 7) currentFreqIndex = 7;
  //if (currentFreqIndex < 0) currentFreqIndex = 0;

  currentFreqIndex=alpha2freq(system_U);

  mytrace("in la_dvs %d System U:%lf\n",currentFreqIndex,system_U);


#ifdef LA_TEST
  gettimeofday(&ovt2,NULL);
  printf("la overhead=%ld\n",ovt2.tv_sec*1000000+ovt2.tv_usec-ovt1.tv_sec*1000000-ovt1.tv_usec);
#endif 

  if (i != currentFreqIndex) {
   
#ifdef SYNC
    my_set_freq(FREQ_POINTS[currentFreqIndex]);
#else
    my_set_freq(currentFreqIndex);
#endif


    /* 		usleep(5000); */

  }

}



/*--Timer interrupt ISR to get into TB.
  Task exec. time exceeds Ca, should jump to
  the maxmum freq. now --*/
static void tbIntISR(void )
{

  struct itimerval nextRelTimer;
  struct itimerval tmpTimer;
  int insched=FALSE;

  pthread_mutex_lock(&mutex_sched);
  insched=in_sched;
  pthread_mutex_unlock(&mutex_sched);

  //alarm(0);
  /*-- enter Tb, come to the highest freq. --*/
 
  if( insched==TRUE){
    mytrace("INT inside scheduler!, delay 200usec and try again!\n"); 
    /* wait for 200 usec to let scheduler() finish, to avoid
     * possible race conditions .
     */
    tmpTimer.it_interval.tv_sec = 0;
    tmpTimer.it_interval.tv_usec = 0;
    tmpTimer.it_value.tv_sec=0;
    tmpTimer.it_value.tv_usec = DELAY_USEC;
    signal(SIGALRM, (void*)tbIntISR);
    setitimer(ITIMER_REAL, &tmpTimer, NULL);
    return;
  
  }

  mytrace("Enter Tb now!\n");

#ifdef SYNC
  my_set_freq("266/133/16");
  currentFreqIndex=MAX_FREQ_INDEX;
#else
  my_set_freq(MAX_FREQ_INDEX);
  currentFreqIndex = MAX_FREQ_INDEX;
#endif

  if(tb2nextRel>0){
    nextRelTimer.it_interval.tv_sec=0;
    nextRelTimer.it_interval.tv_usec=0;
    nextRelTimer.it_value.tv_sec=0;
    while(tb2nextRel>1000000){
      tb2nextRel-=1000000;
      nextRelTimer.it_value.tv_sec++;
    }
    nextRelTimer.it_value.tv_usec=tb2nextRel;

    /*----set up a timer for next ealiest released thread----*/
    if(signal(SIGALRM, (void*)timerhandler)==SIG_ERR){
      perror("Error in registering signal handler\n");
      exit(-1);
    }
      
    setitimer(ITIMER_REAL, &nextRelTimer, NULL);
    //mytrace("leaving tbIntISR():resuming oldTimer: sec=%ld, usec=%ld\n",oldTimer.it_value.tv_sec,oldTimer.it_value.tv_usec);
  }

}


 void setNextRelTimer(long_t  next_reltime)
{
  struct itimerval nextRelTimer;
 

  //mytrace("enter setNextRelTimer\n");
  
  gettimeofday(&CurrentTime, NULL);
  CurrentTime_usec = (long_t  )CurrentTime.tv_usec + (long_t  )1000000*(long_t  )CurrentTime.tv_sec;

  if(CurrentTime_usec >= next_reltime ){
    mytrace("scheduler running behind, curTime> next_reltime\n");
    
    next_reltime=DELAY_USEC;
  }
  else{ 
    next_reltime= next_reltime-CurrentTime_usec;    
  }

  nextRelTimer.it_interval.tv_sec=0;
  nextRelTimer.it_interval.tv_usec=0;
  nextRelTimer.it_value.tv_sec=0;
  while( next_reltime >1000000){
    next_reltime-=1000000;
    nextRelTimer.it_value.tv_sec++;
  }
  nextRelTimer.it_value.tv_usec=next_reltime;
    
  /*----set up a timer for next ealiest released thread----*/
  if(signal(SIGALRM, (void*)timerhandler)==SIG_ERR){
    perror("Error in registering signal handler\n");
    exit(-1);
  }
      
  setitimer(ITIMER_REAL, &nextRelTimer, NULL);
  //mytrace("leaving setNextRelTimer\n");
}





/* int Frequencies[NUM_FREQ] = {33, 44, 66, 133, 266}; */
void setTbInterrupt(long_t  ca, int i, long_t  next_reltime)
{
  int freq;
  long tb_usec, temp_usec;
  struct itimerval tbTimer;
   

  //mytrace("enter setTbInterrupt\n");
  
  if( i < 0 || i > MAX_FREQ_INDEX){
    printf("Error at setTbInterrupt, freqIndex=%d\n", i);
    exit(-1);
  }

  freq=Frequencies[i];

  tb_usec=(long)((double)ca/(double)freq);
  
  //mytrace("setTbInterrupt(): Ca=%lld,i=%d, currentThd=%d,tb_usec=%ld\n",ca,i, currentThread,tb_usec);
  
  
  gettimeofday(&CurrentTime, NULL);
  CurrentTime_usec = (long_t  )CurrentTime.tv_usec + (long_t  )1000000*(long_t  )CurrentTime.tv_sec;
  
  if( CurrentTime_usec+ tb_usec >= next_reltime){
    
    mytrace("shceduler running behind, tb_usec=%lld > next_reltime=%lld\n", CurrentTime_usec+ tb_usec -StartTime_usec, next_reltime  -StartTime_usec);
    
    setNextRelTimer(next_reltime);
    
  }else{
    
    /* set up tb timer, and prepare a 2nd timer for next_reltime thread*/
    
    tb2nextRel= next_reltime-tb_usec-CurrentTime_usec;
    
    temp_usec=tb_usec;
    tbTimer.it_interval.tv_sec = 0;
    tbTimer.it_interval.tv_usec = 0;
    tbTimer.it_value.tv_sec = 0;

    while (tb_usec > 1000000)
      {
	tbTimer.it_value.tv_sec++;
	tb_usec -= 1000000;
      }
    
    tbTimer.it_value.tv_usec= tb_usec;
    
    if(signal(SIGALRM, (void*)tbIntISR)==SIG_ERR){
      perror("Error in registering signal handler\n");
      exit(-1);
    }
    
    if( setitimer(ITIMER_REAL, &tbTimer, NULL)!=0){
      perror("Error in setitimer");
      exit(-1);
    }
    
  } /* end of if( tb_usec > next_reltime) .... */
       
    //mytrace("leaving setTbInt()\n");
    
}




/*--********************************************
  Feedback DVS.
  ********************************************--*/
void dvs_fd( long_t  next_reltime ) {
  

  int i,j;
  double s, x, alpha;
  unsigned cleft;
  int temp;
  int sorted[NUM_THREADS];
  long_t  Dn, ca;
  float startT, endT, lastEnd;
  
#ifdef FD_TEST
  printf("fd get ovt1\n");
  gettimeofday(&ovt1, NULL);
#endif

  //mytrace("enter dvs_fd\n");
   
  system_U = 0.0;
  s = 0.0;

  for (j = 0; j < numThreads-1; j++) {
    system_U += threadList[j].U_la;
  }


  for (j = 0; j < numThreads-1; j++) {
    sorted[j] = j;
    threadList[j].dStarted=FALSE;
  }

  for (i = 0; i < numThreads-1; i++) {
    for (j = i+1; j < numThreads-1; j++) {
      if (threadList[sorted[i]].abs_deadline < threadList[sorted[j]].abs_deadline) {
	temp = sorted[i];
	sorted[i]= sorted[j];
	sorted[j] = temp;
      }
    }
  }

  Dn = threadList[sorted[numThreads-2]].abs_deadline;
  //mytrace("in la_dvs task:%d Dn:%lf\n",sorted[numThreads-2],(double)Dn);
  
  

  for (i = 0 ; i < numThreads-1; i++) {
    system_U = system_U - threadList[sorted[i]].U_la;
    cleft = threadList[sorted[i]].WCEC - threadList[sorted[i]].exec_cycles;
    x = max((double)0, (double)(cleft - (1-system_U)*(((double)threadList[sorted[i]].abs_deadline - (double)Dn)*Frequencies[NUM_FREQ-1])));

    if(threadList[sorted[i]].abs_deadline!= Dn)
      system_U = system_U+(double)((double)((double)((double)cleft-x))/(double)((((double)threadList[sorted[i]].abs_deadline - (double)Dn)*Frequencies[NUM_FREQ-1])));
    s = s+x;
  }


  gettimeofday(&CurrentTime, NULL);
  CurrentTime_usec = (long_t  )CurrentTime.tv_usec + (long_t  )1000000*(long_t  )CurrentTime.tv_sec;

  if(currentThread<0){
    printf("Error at dvs_fd: currentThread=%d\n",currentThread);
    exit(-1);
  }
  if( Dn == threadList[currentThread].abs_deadline ){
    
    /*---- if Dn is current thread's deadline, split current thread
      into Ta and Tb  ----*/

    if(s< (Dn-CurrentTime_usec)*Frequencies[NUM_FREQ-1])
      threadList[currentThread].slack=(double)((Dn - CurrentTime_usec)*Frequencies[NUM_FREQ-1]-s);
    else 
      threadList[currentThread].slack=0;
    
    //mytrace("dvs_df: dvs_fd():slack=%lld, Ca=%lld, exec_cyc=%lld\n",threadList[currentThread].slack,threadList[currentThread].Ca, threadList[currentThread].exec_cycles);

    if(threadList[currentThread].Ca> threadList[currentThread].exec_cycles){
      ca=threadList[currentThread].Ca- threadList[currentThread].exec_cycles;
     
    }else {

      /*-- If the task has already executed longer than Ca, assuming a worst case here, i.e., cc=WCET.
	May look for some better huristics in the future --*/
      ca=threadList[currentThread].WCEC- threadList[currentThread].exec_cycles;
      //mytrace("wcec=%lld, cyc=%lld, ca=%lld\n", threadList[currentThread].WCEC, threadList[currentThread].exec_cycles, ca);
    }

    alpha = (double)ca/(double)(ca+threadList[currentThread].slack);

    /*---- map alpha into a freq.level ----*/
    i = alpha2freq(alpha);
    //printf("[%d]:%llu %f %d\n", currentThread, threadList[currentThread].slack, alpha, i);

    //mytrace("dvs_fd: alpha=%f, freq=%d\n", alpha, i);

    if (i != currentFreqIndex) {
#ifdef SYNC
      my_set_freq(FREQ_POINTS[i]);  
#else
      my_set_freq(i);
#endif

      currentFreqIndex=i;
    }
    /*---- end of freq. mapping -----*/

    /*---- get into Tb portion only when exec_cycles are 
      less than the previous Ca. Otherwise, not necessary 
      to get into Tb since the entire task can complete in Ta.----*/
    if(threadList[currentThread].Ca> threadList[currentThread].exec_cycles && ( i!= MAX_FREQ_INDEX ) ){

      /*-- set up interrupt handler at the end of Ta --*/
      setTbInterrupt(ca,i, next_reltime);
      
    } else{
      /*-- set up a timer which triggers at the next earliest thread release time*/
      setNextRelTimer(next_reltime);
    }

#ifdef FD_TEST
    gettimeofday(&ovt2,NULL);
    schd_overhead+=ovt2.tv_sec*1000000+ovt2.tv_usec-ovt1.tv_sec*1000000-ovt1.tv_usec;
    schd_num++;
    printf("fd overhead=%ld\n",schd_overhead);
#endif


  }else{

    /*---- Dn < current thread's deadline, do not split any more ----*/

    system_U = s/((double)((double)((Dn - CurrentTime_usec))*Frequencies[NUM_FREQ-1]));
    i=alpha2freq(system_U);
#ifdef FD_TEST
    gettimeofday(&ovt2,NULL);
    printf("fd overhead=%ld\n",ovt2.tv_sec*1000000+ovt2.tv_usec-ovt1.tv_sec*1000000-ovt1.tv_usec);
#endif

    if (i != currentFreqIndex) {
#ifdef SYNC
      my_set_freq(FREQ_POINTS[i]);  
#else
      my_set_freq(i);
#endif
      currentFreqIndex=i;
    }

    /*-- set up a timer which triggers at the next earliest thread release time*/
    setNextRelTimer(next_reltime);
    
  }
  
  //mytrace("leaving dvs_fd\n");
  
}
  


/*return the amount of slack in [start,end] available to the current task*/
long_t  allocateTask(long_t  start, long_t  end)
{
  int i;
  long_t  t;

  t=(end-start);
  //mytrace("allocateTask: end-start=%lld\n",t);

  for (i=0;i<numThreads-1;i++){
    
    if( (sortedQ[i]==currentThread) 
	&& (threadList[sortedQ[i]].dr==threadList[currentThread].release)){
      /*do not allocate exec. time for the current task job */
      //mytrace("allocate: case 1\n");
      continue;
    }
	  
    if( (threadList[sortedQ[i]].dC>0) && (threadList[sortedQ[i]].dC<=t) 
	&& (threadList[sortedQ[i]].release<end)){
      //mytrace("allocate: case 2\n");
      t-=threadList[sortedQ[i]].dC;
      //printf("allocate task %d for %f\n",sortedQ[i],threadList[sortedQ[i]].dC);
      threadList[sortedQ[i]].dC=0;
      threadList[sortedQ[i]].dr-=threadList[sortedQ[i]].period;
      threadList[sortedQ[i]].dStarted=FALSE;
	    
    }
    else if( threadList[sortedQ[i]].dC>0 && threadList[sortedQ[i]].dC>t
	     && threadList[sortedQ[i]].release<end ){ 
      threadList[sortedQ[i]].dC-=t;
      //printf("allocate task %d for %f, rem=%f\n",sortedQ[i],t,threadList[sortedQ[i]].dC);
      mytrace("allocate case 3\n");
      t=0;
    }

    if(t<=0)
      break;
  }
	
  if(end>threadList[currentThread].abs_deadline){
    t=0;
    //mytrace("allocate case 4\n");
  }

  //printf("available exec. time=%f\n",t);
  //mytrace("allocateTask=%lld\n",t);
  return t;
}




/*update dynamic WCET in [start, end] and dynamic release time of each task.
  return start time
*/
long_t  getPrevDeadline(long_t  end, long_t  curTime)
{
  long_t  i,key,rem;
  long_t  start;
  int j, idx;

  start=0;

  for(i=0;i<numThreads-1;i++){
    if(threadList[i].dr>=0 && threadList[i].release<end ){
      rem =  end % threadList[i].period;
      if(rem==0){
	rem=end-threadList[i].period;
      }
      else  {
	rem=end-rem;
      }
      if(rem>=start)
	start=rem;
    }
  }

  if(start<curTime)
    start=curTime;  
  
  for(i=0;i<numThreads-1;i++){ 
    if( ( end % (threadList[i].period) == 0) && (threadList[i].release<end)) {
      /* task.deadline= end */
      threadList[i].dr=end-threadList[i].period;
      if( (threadList[i].dr<=curTime) && (threadList[i].exec_cycles > 0 ) )
        /* this job has been previously preempted. Now it should resume exec. */
        threadList[i].dC= (long_t )((float)(threadList[i].WCEC-threadList[i].exec_cycles)/(float)Frequencies[NUM_FREQ-1]);
      else
        /* no preemption , always use WCET as dC */
	threadList[i].dC=threadList[i].WCET;
     
      threadList[i].dStarted=TRUE;
    }
    else if( ( (int)start % threadList[i].period ==0)
	     && ( (start+threadList[i].period)!=end )
	     && (threadList[i].dStarted==FALSE )) {
      /*task.releaseTime=start , task.deadline>end */
      if(end==largestDeadline || ( threadList[i].dr==start && threadList[i].dC<=0) ){
	threadList[i].dC+=threadList[i].U*(end-start);
	threadList[i].dr=start;
	threadList[i].dStarted=TRUE;
      }
    }
    else if ( ((int)end % (threadList[i].period) != 0)
	      &&(start % threadList[i].period !=0 )
	      && (end==largestDeadline || (threadList[i].dC==0
					   && threadList[i].dr==((int)end- ((int)end % (threadList[i].period)))))){
      /* the task is released before [start]. Its deadline is after [end]. */
      rem=(long_t )end % (threadList[i].period);           
      threadList[i].dC+= threadList[i].U*rem;
      threadList[i].dr=end- rem;
      threadList[i].dStarted=TRUE;
             
    }
  }

  /*sort sortedQ[] by threadList's dr */
  sortedQ[0]=0;
  idx=0;
  for (j=1;j<numThreads-1;j++){
    key=threadList[j].dr;
    idx=j-1;    
    while(idx>=0 && threadList[sortedQ[idx]].dr < key ){
      sortedQ[idx+1]=sortedQ[idx];
      idx--;
    }
    sortedQ[idx+1]=j;
  }

  //printf("startT=%d,endT=%d\n",ret,end);

  return start;
}


/*--********************************************
  Original Feedback DVS.
  ********************************************--*/
void dvs_org_fd( long_t  next_reltime ) {
  

  int i,j;
  double s, x, alpha;
  unsigned cleft;
  int temp;
  int sorted[NUM_THREADS];
  long_t  Dn, ca;
  long_t  startT, endT, lastEnd;
  long_t  idle=0;  /* changed into cycles!! not exec. time!! */
  long_t  lastidle=0;
  
#ifdef FD_TEST
  printf("fd get ovt1\n");
  gettimeofday(&ovt1, NULL);
#endif

  mytrace("enter dvs_org_fd\n");
   
  system_U = 0.0;
  s = 0.0;

  for (j = 0; j < numThreads-1; j++) {
    system_U += threadList[j].U_la;
  }


  for (j = 0; j < numThreads-1; j++) {
    sorted[j] = j;
    threadList[j].dStarted=FALSE;
  }

  for (i = 0; i < numThreads-1; i++) {
    for (j = i+1; j < numThreads-1; j++) {
      if (threadList[sorted[i]].abs_deadline < threadList[sorted[j]].abs_deadline) {
	temp = sorted[i];
	sorted[i]= sorted[j];
	sorted[j] = temp;
      }
    }
  }

  Dn = threadList[sorted[numThreads-2]].abs_deadline;
  //mytrace("in la_dvs task:%d Dn:%lf\n",sorted[numThreads-2],(double)Dn);

  gettimeofday(&CurrentTime, NULL);
  CurrentTime_usec = (long_t  )CurrentTime.tv_usec + (long_t  )1000000*(long_t  )CurrentTime.tv_sec;

  
  endT=threadList[sorted[0]].abs_deadline;
  largestDeadline=endT;
  startT=getPrevDeadline(endT,CurrentTime_usec);

  while(endT > CurrentTime_usec){   
    /*allocate Task in [startT, endT]*/
    lastidle=idle;
    lastEnd=endT;
    idle+=allocateTask(startT,endT);
    endT=startT;
    startT=getPrevDeadline(endT,CurrentTime_usec);
  }

  

  if(currentThread<0){
    printf("Error at dvs_fd: currentThread=%d\n",currentThread);
    exit(-1);
  }

  /*convert idle from wall-clock time into cycles !*/
  idle*=Frequencies[NUM_FREQ-1];

  if( idle <= ( threadList[currentThread].WCEC-threadList[currentThread].exec_cycles ))
    threadList[currentThread].slack=0;
  else
    threadList[currentThread].slack=(idle-( threadList[currentThread].WCEC-threadList[currentThread].exec_cycles ));


    if(threadList[currentThread].Ca> threadList[currentThread].exec_cycles){
      ca=threadList[currentThread].Ca- threadList[currentThread].exec_cycles;
     
    }else {

      /*-- If the task has already executed longer than Ca, assuming a worst case here, i.e., cc=WCET.
	May look for some better huristics in the future --*/
      ca=threadList[currentThread].WCEC- threadList[currentThread].exec_cycles;
      //mytrace("wcec=%lld, cyc=%lld, ca=%lld\n", threadList[currentThread].WCEC, threadList[currentThread].exec_cycles, ca);
    }

  alpha = (double)ca/(double)(ca+threadList[currentThread].slack);


  /*---- map alpha into a freq.level ----*/
  i = alpha2freq(alpha);
  mytrace("\ndvs_org_fd:idle=%lld, Ca=%lld, exec_cyc=%lld, slack=%lld, ca=%lldd, alpha=%f,next freq=%d\n",
	  idle, threadList[currentThread].Ca,threadList[currentThread].exec_cycles,threadList[currentThread].slack,
	  ca,alpha, i);

  if (i != currentFreqIndex) {
#ifdef SYNC
    my_set_freq(FREQ_POINTS[i]);  
#else
    my_set_freq(i);
#endif

    currentFreqIndex=i;
  }

  //mytrace("dvs_fd: alpha=%f, freq=%d\n", alpha, i);
  /*---- get into Tb portion only when exec_cycles are 
    less than the previous Ca. Otherwise, not necessary 
    to get into Tb since the entire task can complete in Ta.----*/
  if(threadList[currentThread].Ca> threadList[currentThread].exec_cycles && ( i!= MAX_FREQ_INDEX ) ){

    fprintf(stderr, "%d ", currentThread);
    /*-- set up interrupt handler at the end of Ta --*/
    setTbInterrupt(ca,i, next_reltime);
      
  }else{
    /*-- set up a timer which triggers at the next earliest thread release time*/
    setNextRelTimer(next_reltime);
  }
  

#ifdef FD_TEST
  gettimeofday(&ovt2,NULL);
  printf("fd overhead=%ld\n",ovt2.tv_sec*1000000+ovt2.tv_usec-ovt1.tv_sec*1000000-ovt1.tv_usec);
#endif


  /*---- end of freq. mapping -----*/
  mytrace("leaving dvs_org_fd\n");

}
  



/* 
 * there may be some race conditions between timerhandler and the scheduler.
 */
static void timerhandler (void)
{

  struct itimerval tmpTimer;

  int i;
  int insched=FALSE;

  pthread_mutex_lock(&mutex_sched);
  insched=in_sched;
  pthread_mutex_unlock(&mutex_sched);

  if( insched==TRUE || currentThread<0 || currentFreqIndex <0 || currentFreqIndex> MAX_FREQ_INDEX ){
    mytrace("timerhandler inside scheduler. Delay 200usec and try again\n");
    /* wait for 200 usec to let scheduler() finish, to avoid
     * possible race conditions .
     */
    tmpTimer.it_interval.tv_sec = 0;
    tmpTimer.it_interval.tv_usec = 0;
    tmpTimer.it_value.tv_sec=0;
    tmpTimer.it_value.tv_usec = DELAY_USEC;
    signal(SIGALRM, (void*)timerhandler);
    setitimer(ITIMER_REAL, &tmpTimer, NULL);
    return;
  
  }

  alarm(0);
  mytrace("in alarm handler\n",0,0);

  if(sigsetjmp(threadList[currentThread].context,1)!=0)
    {
      /* returnning from longjmp using the saved context */
     
      gettimeofday(&PrintTime, NULL);
      PrintTime_usec = (long_t )PrintTime.tv_usec + (long_t )1000000*(long_t )PrintTime.tv_sec;
      mytrace( " timerhandler(): Resuming thread %d\n",currentThread );
	
      if(DVS==DVS_AGR || DVS==DVS_OTE)
	last_event_time=PrintTime_usec;
     

      
      pthread_mutex_lock( &mutex_sched );
      in_sched=FALSE;
      pthread_mutex_unlock( &mutex_sched );

      return;
    }
  else
    {
      mytrace("leaving timerhandler\n");
      Scheduler(1,0);
    }

}


static void CreateNewContext( int argument )
{
  mytrace( "CreateNewContext(): Signal handler for thread %d\n", numThreads,0 );

  if(numThreads<0 || numThreads>=MAX_THREADS ){
    fprintf(stderr,"Error at CreateNewContext, numThreads=%d\n",numThreads);
    exit(-1);
  }
  /* Save the current context, and return to terminate the signal handler scope */
  if ( sigsetjmp( threadList[numThreads].context , 1 ))
    {
      /* We are being called again from the main context. Call the function */
      gettimeofday(&PrintTime, NULL);
      PrintTime_usec = (long_t )PrintTime.tv_usec + (long_t )1000000*(long_t )PrintTime.tv_sec;
      mytrace( "CreateNewContext():Starting thread %d at time %lld\n******\n", currentThread, PrintTime_usec-StartTime_usec);
      if( (DVS==DVS_AGR||DVS==DVS_OTE) && currentThread!=3 ){
	
		last_event_time=PrintTime_usec;
	
	}

           
      pthread_mutex_lock( &mutex_sched );
      in_sched=FALSE;
      pthread_mutex_unlock( &mutex_sched );
      

      threadList[currentThread].function(threadList[currentThread].arg);
    }

  return;
}

void initThreads()
{
  int i,j;

  my_dpm_init();
  for ( i = 0; i < MAX_THREADS; ++ i )
    {
      threadList[i].stack = 0;
      threadList[i].function = 0;
      threadList[i].arg=0;
      threadList[i].active = false;
      threadList[i].WCET = 0;
      threadList[i].period = 0;
      threadList[i].deadline = 0;
      threadList[i].abs_deadline = 0;
      threadList[i].phase = 0;
      threadList[i].next_release = 0;
      release_vector[i] = false;
      threadList[i].slack=0;
      threadList[i].Ca=0;
      threadList[i].ccHead=-1;
    }

  avgErr.head=-1;
  /*---- initialize errors to zero ----*/
  for(j=0;j<MAX_ERR_ITEMS;j++)
    avgErr.err[j]=0;

  gettimeofday(&StartTime, NULL);
  StartTime_usec = (long_t )StartTime.tv_usec + (long_t )1000000*(long_t )StartTime.tv_sec;

  /* 	mytrace("%ld.%ld\nstart time: %lf\n", StartTime.tv_sec,StartTime.tv_usec,(double)StartTime_usec); */
  mytrace("initThreads(): done initilizing...\n");

  return;
}


/* times are in usec */
int spawnThread( void (*func)(void), long_t  WCET, long_t  period, long_t  deadline, long_t  phase)
{
  struct sigaction handler;
  struct sigaction oldHandler;
  int i;
  stack_t stack;
  stack_t oldStack;

  if ( numThreads == MAX_THREADS ) return MAXTHREADS;

  /* 	 Create the new stack */
  stack.ss_flags = 0;
  stack.ss_size = THREAD_STACK;
  stack.ss_sp = malloc( THREAD_STACK );
  if ( stack.ss_sp == 0 )
    {
      mytrace( "SpawnThreads(): Error: Could not allocate stack.\n" );
      exit(-1);
      return MALLOCERROR;
    }
  //mytrace( "SpawnThreads(): Stack address from malloc = 0x%x\n", stack.ss_sp );

  /* 	 Install the new stack for the signal handler */
  if ( sigaltstack( &stack, &oldStack ) )
    {
      mytrace( "SpawnThreads(): Error: sigaltstack failed.\n" );
      exit(-1);
      return SIGNALERROR;
    }

  /* 	 Install the signal handler */
  /* 	 Sigaction *must* be used so we can specify SA_ONSTACK */
  handler.sa_handler = &CreateNewContext;
  handler.sa_flags = SA_ONSTACK;
  sigemptyset( &handler.sa_mask );

  if ( sigaction( SIGUSR1, &handler, &oldHandler ) )
    {
      mytrace( "SpawnThreads(): Error: sigaction failed.\n" );
      exit(-1);
      return SIGNALERROR;
    }

  /* 	 Call the handler on the new stack */
  if ( raise( SIGUSR1 ) )
    {
      mytrace( "SpawnThreads(): Error: raise failed.\n" );
      exit(-1);
      return SIGNALERROR;
    }

  /* 	 Restore the original stack and handler */
  sigaltstack( &oldStack, 0 );
  sigaction( SIGUSR1, &oldHandler, 0 );

  /* 	 We now have an additional thread, ready to roll */
  threadList[numThreads].active = true;
  //threadList[numThreads].function =func;
  threadList[numThreads].stack = stack.ss_sp;
  threadList[numThreads].WCET = WCET;
  threadList[numThreads].WCEC = WCET*Frequencies[NUM_FREQ-1];
  mytrace( "Spawn_Threads():WCEC %lf\n",(double)threadList[numThreads].WCEC ); 
  threadList[numThreads].period = period;
  threadList[numThreads].phase = phase;
  threadList[numThreads].deadline = deadline;
  threadList[numThreads].abs_deadline = StartTime_usec + deadline;
  threadList[numThreads].release=StartTime_usec;
  threadList[numThreads].next_release = StartTime_usec + period;
  threadList[numThreads].Ca = (long_t )((double)threadList[numThreads].WCEC);
  threadList[numThreads].exec_cycles  = 0;
  threadList[numThreads].slack=0;
  threadList[numThreads].dr=0.0;
  threadList[numThreads].dC=0.0;
  threadList[numThreads].dStarted=FALSE;

  /*---- initially prevcc are all set to be WCEC ----*/
  for(i=0;i<CCWIN;i++){
    threadList[numThreads].prevcc[i]=threadList[numThreads].WCEC;
  }

  if (threadList[numThreads].period != 0) {
    threadList[numThreads].U = (double)threadList[numThreads].WCET/(double)threadList[numThreads].period;
    threadList[numThreads].U_cc = threadList[numThreads].U ;
    threadList[numThreads].U_la = threadList[numThreads].U ;
    mytrace( "Spawn_Threads():U %lf\n",threadList[numThreads].U ); 
    system_U += threadList[numThreads].U;

  }

  ++ numThreads;  

  return NOERROR;
}




/* create a new thread, with arguments. times are in usec. deadline==period */
int spawnThreadArg( void (*func)(int), int arg, long_t wcet, long_t period)
{
  struct sigaction handler;
  struct sigaction oldHandler;
  int i;
  stack_t stack;
  stack_t oldStack;

  if ( numThreads == MAX_THREADS ) return MAXTHREADS;

  /* 	 Create the new stack */
  stack.ss_flags = 0;
  stack.ss_size = THREAD_STACK;
  stack.ss_sp = malloc( THREAD_STACK );
  if ( stack.ss_sp == 0 )
    {
      mytrace( "SpawnThreads(): Error: Could not allocate stack.\n" );
      exit(-1);
      return MALLOCERROR;
    }
  //mytrace( "SpawnThreads(): Stack address from malloc = 0x%x\n", stack.ss_sp );

  /* 	 Install the new stack for the signal handler */
  if ( sigaltstack( &stack, &oldStack ) )
    {
      mytrace( "SpawnThreads(): Error: sigaltstack failed.\n" );
      exit(-1);
      return SIGNALERROR;
    }

  /* 	 Install the signal handler */
  /* 	 Sigaction *must* be used so we can specify SA_ONSTACK */
  handler.sa_handler = &CreateNewContext;
  handler.sa_flags = SA_ONSTACK;
  sigemptyset( &handler.sa_mask );

  if ( sigaction( SIGUSR1, &handler, &oldHandler ) )
    {
      mytrace( "SpawnThreads(): Error: sigaction failed.\n" );
      exit(-1);
      return SIGNALERROR;
    }

  /* 	 Call the handler on the new stack */
  if ( raise( SIGUSR1 ) )
    {
      mytrace( "SpawnThreads(): Error: raise failed.\n" );
      exit(-1);
      return SIGNALERROR;
    }

  /* 	 Restore the original stack and handler */
  sigaltstack( &oldStack, 0 );
  sigaction( SIGUSR1, &oldHandler, 0 );

  /* 	 We now have an additional thread, ready to roll */
  threadList[numThreads].active = true;
  threadList[numThreads].function = func;
  threadList[numThreads].arg=arg;
  threadList[numThreads].stack = stack.ss_sp;
  threadList[numThreads].WCET = wcet;
  threadList[numThreads].WCEC = wcet*Frequencies[NUM_FREQ-1];
  mytrace( "Spawn_Threads():WCEC %lf\n",(double)threadList[numThreads].WCEC ); 
  threadList[numThreads].period = period;
  threadList[numThreads].phase = 0;
  threadList[numThreads].deadline = period;
  threadList[numThreads].abs_deadline = StartTime_usec + period;
  threadList[numThreads].release=StartTime_usec;
  threadList[numThreads].next_release = StartTime_usec + period;
  threadList[numThreads].Ca = (long_t )((double)threadList[numThreads].WCEC);
  threadList[numThreads].exec_cycles  = 0;
  threadList[numThreads].slack=0;
  threadList[numThreads].dr=0.0;
  threadList[numThreads].dC=0.0;
  threadList[numThreads].dStarted=FALSE;

  /*---- initially prevcc are all set to be WCEC ----*/
  for(i=0;i<CCWIN;i++){
    threadList[numThreads].prevcc[i]=threadList[numThreads].WCEC;
  }

  if (threadList[numThreads].period != 0) {
    threadList[numThreads].U = (double)threadList[numThreads].WCET/(double)threadList[numThreads].period;
    threadList[numThreads].U_cc = threadList[numThreads].U ;
    threadList[numThreads].U_la = threadList[numThreads].U ;
    mytrace( "Spawn_Threads():U %lf\n",threadList[numThreads].U ); 
    system_U += threadList[numThreads].U;

  }

  ++ numThreads;  
  return NOERROR;
}



int spawnMultiThd( void (*func)(int),  int taskNum, float U, float ccWC, long_t base, unsigned int load )
{
  float aU, curU;  /* utilization of a single task */
  long_t  period, gcd, wcet;
  int i;
  
  curU=0;
  loadType = load;   /* Santhosh: type of load */

  for(i=0;i<taskNum;i++){

    period=1;
    if(i==taskNum-1){
      aU=U-curU;
    }
    else{
      /* the actual utilization of each task lies within [0.3,1.7]U/taskNum */
      aU= (((double)rand()/RAND_MAX) * (1.7-0.3) + 0.3)*U/(float)taskNum ;
      while (aU >= (U)){
	aU=0.5*aU;
      }
    }
    
    curU+=aU;
    
    while(aU<10){
      aU*=10;
      period*=10;
    }
    wcet=(long_t )aU;
    gcd=getGCD(wcet,period);
    wcet/=gcd;
    period/=gcd;
    

    spawnThreadArg(func, wcet, wcet*base, period*base);
  }
  
}


/*---- the average distance between each task's Ca 
  and its last job's actual exec. time ----*/
 
void insertError(void)
{

  int i;
  long long int avgDis=0;
  //mytrace("enter insertError\n");
  for ( i = 0; i < numThreads-1; ++ i )
    {
      
      if( threadList[i].ccHead!=-1){
	if(threadList[i].ccHead < 0 || threadList[i].ccHead >=CCWIN){
	  printf("Error at insertError: prevcc[%d]\n", threadList[i].ccHead);
	  exit(-1);
	}
	avgDis+=(threadList[i].Ca-threadList[i].prevcc[threadList[i].ccHead]);
	//mytrace("ca task %d DIs=%lld=%lld-%lld\n",i,avgDis,threadList[i].Ca,threadList[i].prevcc[threadList[i].ccHead]);
      }
    }

  avgDis=(long long int)((double)avgDis/(double)(numThreads-1));

  avgErr.head++;
  if(avgErr.head<0 || avgErr.head> MAX_ERR_ITEMS){
    printf("Error at insertError(): avgErr.head =%d\n", avgErr.head);
    exit(-1);
  }
  if( avgErr.head==MAX_ERR_ITEMS)
    avgErr.head=0;

  avgErr.err[avgErr.head]=avgDis;
  //mytrace("ca insert avgErr: %lld\n",avgDis);

  //mytrace("leaving insertError\n");
}


/*---- insert exec_cycles cc into threadID's prevcc queue ---*/
void insertCC( int threadID, long_t  cc )
{
  //mytrace("enter insertCC\n");
  if(threadID<0 ){
    printf("Error at insertCC: threadID=%d\n", threadID);
    exit(-1);
  }

  threadList[threadID].ccHead++;
  if(threadList[threadID].ccHead==CCWIN)
    threadList[threadID].ccHead=0;

  if(threadList[threadID].ccHead < 0 || threadList[threadID].ccHead >=CCWIN){
    printf("Error at insertCC: prevcc[%d]\n", threadList[threadID].ccHead);
    exit(-1);
  }

  threadList[threadID].prevcc[threadList[threadID].ccHead]=cc;

  if(threadList[threadID].ccHead<0 || threadList[threadID].ccHead >= CCWIN){
    perror("Error at insertCC(): ccHead out of bound\n");
    exit(-1);
  }
  //mytrace("leaving insertCC\n");
}


/*---- adjust Ca for next job using PID feedback ----*/
long_t  getPID(int thdID )
{
  int idx1, idx2, idx3;
  long_t  ca;
  long_t  sum;
  int item;
  int i, dPrev;
  long_t  deltaCa;


  //mytrace("enter getPID\n");
  /*---- predict next Ca using curve fitting with a
    polynomial of an order of 2----*/
  if(thdID<0 ){
    printf("Error at getPID: threadID=%d\n", thdID);
    exit(-1);
  }
  idx3=threadList[thdID].ccHead;
  if(idx3==-1)
    idx3=CCWIN-1;
  
  if(idx3 <0 || idx3 >= CCWIN){
    perror("Error at getPID(): ccHead out of bound\n");
    exit(-1);
  }

  idx2=idx3-1;
  if(idx2==-1)
    idx2=CCWIN-1;
  idx1=idx2-1;
  if(idx1==-1)
    idx1=CCWIN-1;
  
#ifdef POLYNOMIAL_PRED
  /*---- predict Ca for the next job ----*/
  ca=threadList[thdID].prevcc[idx1]-3*threadList[thdID].prevcc[idx2]+3*threadList[thdID].prevcc[idx3];
#endif 

#ifdef SIMPLE_FEEDBACK
  ca=(long_t )((double)(threadList[thdID].prevcc[idx1]+threadList[thdID].prevcc[idx2]+threadList[thdID].prevcc[idx3])/3.0);


  //mytrace("ca by prediction: last cc=(%lld,%lld,%lld),ca=%lld\n", threadList[thdID].prevcc[idx3],threadList[thdID].prevcc[idx2],threadList[thdID].prevcc[idx1],ca);
#endif

 
#ifdef PID_FEEDBACK

  /*----  adjust ca according to PID ----*/ 
  sum=0;
  item=0;

  i=avgErr.head;
  if(i==-1 || i>=MAX_ERR_ITEMS){
    perror("avgErr.head==-1\n");
    exit(-1);
  }

  while(item<MAX_INTEGRATION_ITEM){
    sum+=avgErr.err[i];
    //mytrace("ca avgErr.err[%d]=%lld...",i,avgErr.err[i]);
    i--;
    if(i==-1)i=MAX_ERR_ITEMS-1;
    item++;
  }
  //mytrace("\n");
  dPrev=avgErr.head-1;
  if(dPrev==-1)dPrev=MAX_ERR_ITEMS-1;

  deltaCa=(long_t )(P_P*(double)avgErr.err[avgErr.head]+P_I*(double)sum+P_D*(double)(avgErr.err[avgErr.head]-avgErr.err[dPrev]));
  ca+=deltaCa;
  //mytrace("ca ajusted after PID: deltaCa=%lld,avgErr=%lld,sum=%lld,ca=%lld\n",deltaCa,avgErr.err[avgErr.head],sum, ca);
  
#endif

  //mytrace("leaving getPID\n");
  return ca;
}









/*---- post work in feedback-DVS after each task completes ----*/
void post_fd(void)
{
  //mytrace("enter post_fd\n");
  /*----store cc into .prevcc ----*/
  if(currentThread<0){
    printf("Error at post_fd(): currentThread<0\n");
    exit(-1);
  }
  insertCC(currentThread, threadList[currentThread].exec_cycles );
  

  /*----task exec_cycles will be cleared to be 0 at timer handler anyway.
    no need to set it here ----*/
  //threadList[currentThread].exec_cycles = threadList[currentThread].WCEC;

  /*---- compute the average difference bwteen Ca and cc and insert it
    into a queue ----*/
  insertError();
 
  threadList[currentThread].exec_cycles = threadList[currentThread].WCEC;

  /*---- compute a Ca for next job according to PID feedback ----*/
  threadList[currentThread].Ca= getPID(currentThread);

  //ideal case:
  //threadList[currentThread].Ca=threadList[currentThread].prevcc[threadList[currentThread].ccHead ];

  //mytrace("ca Ca/WCEC=%f\n", (double)threadList[currentThread].Ca/threadList[currentThread].WCEC);
  if(threadList[currentThread].Ca> threadList[currentThread].WCEC)
    threadList[currentThread].Ca= threadList[currentThread].WCEC;
  if(threadList[currentThread].Ca <0 )
    threadList[currentThread].Ca=0;
     
  //mytrace("leaving post_fd\n");

}






void threadYield()
{

  pthread_mutex_lock( &mutex_sched );
  in_sched=TRUE;
  pthread_mutex_unlock( &mutex_sched );

  mytrace("Enter yield()\n");
  alarm(0);

  if(currentThread<0 || currentFreqIndex <0 || currentFreqIndex> MAX_FREQ_INDEX ){
    printf("Error at threadYield: currentThread=%d, currentFreqIndex=%d\n",currentThread, currentFreqIndex);
    exit(-1);
  
  }

 
  if(sigsetjmp(threadList[currentThread].context,1)>0)
    {
      gettimeofday(&PrintTime, NULL);
      PrintTime_usec = (long_t )PrintTime.tv_usec + (long_t )1000000*(long_t )PrintTime.tv_sec;
      mytrace( "Time: %0f, threadYield(): Starting Thread %d\n", (double)PrintTime_usec-StartTime_usec, currentThread );
      if(DVS==DVS_AGR || DVS==DVS_OTE){
		last_event_time=PrintTime_usec;
	}
      pthread_mutex_lock( &mutex_sched );
      in_sched=FALSE;
      pthread_mutex_unlock( &mutex_sched );
      return;
    }
  else
    {


      //mytrace("!!!Yield save context()\n");

      gettimeofday(&PrintTime, NULL);
      PrintTime_usec = (long_t )PrintTime.tv_usec + (long_t )1000000*(long_t )PrintTime.tv_sec;
      mytrace( "\n********\nthreadYield(): Thread %d Done at time %lld, exec_time=%lld\n*******\n", currentThread, PrintTime_usec-StartTime_usec,PrintTime_usec-threadList[currentThread].start);
      mytrace( "absDeadline: %lld \n", threadList[currentThread].abs_deadline-StartTime_usec);

     
      threadList[currentThread].active = false;


      gettimeofday(&CurrentTime, NULL);
      CurrentTime_usec = (long_t )CurrentTime.tv_usec + (long_t )1000000*(long_t )CurrentTime.tv_sec;

      threadList[currentThread].exec_cycles += ((CurrentTime_usec - threadList[currentThread].start)*(long_t )Frequencies[currentFreqIndex]);


      if (DVS == DVS_CC)
	{
	  /* Ravi 04/21/2004 */
	  dvs_cc(1,currentThread);
	} 
      else if (DVS == DVS_LA || DVS==DVS_ORG_LA) {
	threadList[currentThread].exec_cycles = threadList[currentThread].WCEC;
      }
      else if (DVS == DVS_FD || DVS== DVS_ORG_FD ){
	post_fd();
      }
      else if (DVS==DVS_AGR||DVS==DVS_OTE){
	updateAlphaQ(&alphaQ, (CurrentTime_usec-last_event_time));
      } 
      
      pthread_mutex_lock( &mutex_sched );
      in_sched=FALSE;
      pthread_mutex_unlock( &mutex_sched );
      
      Scheduler(0,currentThread);
    }
  
}


void speed_reduce(long_t  B, float S)
{
	float wx, alpha;
	int i;

	wx=(float)(threadList[currentThread].WCEC-threadList[currentThread].exec_cycles)/(float)threadList[currentThread].canon_freq;
	alpha=wx*S/(wx+(double)B);
	i=alpha2freq(alpha);
	
	threadList[currentThread].canon_freq=Frequencies[i];

	if(i!=currentFreqIndex){
#ifdef SYNC
	  my_set_freq(FREQ_POINTS[i]);  
#else
	  my_set_freq(i);
#endif
	  
	  currentFreqIndex=i;
	}

}


long_t  earliness(void)
{
  long_t  ret=0;
  a_Q * ptr=alphaQ;
  
  while(ptr!=NULL){
    if(ptr->id!=currentThread && ptr->d<=threadList[currentThread].abs_deadline){
      ret+=ptr->rem;
     
    }
    ptr=ptr->next;
      
  }

  return ret;

}

int speed_inc(int id, long_t  wx, long_t  H )
{
  int ret;
  float alpha;

  alpha=((float)wx/(float)(wx- H))*(float)threadList[id].canon_freq;

  ret=alpha2freq(alpha);
  return ret;
}



void aggr_spd_adj(long_t  NTA,long_t  slack )
{
  long_t  Q, Qact, wx,wxj, w2,Z=0,req_time, B;
  int id2;
  int r,j, Sj;
  a_Q * ptr, *curPtr;
  
  
  if (threadList[currentThread].canon_freq <= AGR_K * opt_avg_freq)
    return;

  wx= (float)(threadList[currentThread].WCEC-threadList[currentThread].exec_cycles)/(float)threadList[currentThread].canon_freq;
  Q= (((float)threadList[currentThread].canon_freq/max(Frequencies[0],AGR_K*opt_avg_freq))-1)*wx;
  
  /* note: slack = NTA-t-w_{1}^{S1}(t) */
  if(slack <Q){
    Q=slack;
  }

  Qact=0;

  /* figure out the 2nd EDF* task that are ready,
   or that are completed but have their unused exec.
   time left in the alpha queue with EDF* priority 
   less than the currentTask */

 

  if(alphaQ==NULL || alphaQ->next==NULL){
    /* if there is less than 2 tasks in the alpha queue, 
       return immediately 
    */
    return;
  }
  ptr=alphaQ;
 
  while(ptr!=NULL && ptr->id!=currentThread ){
    ptr=ptr->next;
  }
  
  if(ptr==NULL){
    return;
  }

  curPtr=ptr;
  /* from ptr on, all elements in the alpha Queue
     have a lower EDF* priority than the current 
     task 
  */
  ptr=ptr->next;

  if(ptr==NULL)
    return;

  id2=ptr->id;
  

  w2=(float)(threadList[id2].WCEC-threadList[id2].exec_cycles)/(float)threadList[id2].canon_freq;
  if(w2>=Q){
    r=1;
    Z=0;
  }else{
    /* find the largest r such that Z=Sigma(w2..r)<=Q */
    r=1;
    Z=0;
    ptr=ptr->next;
    while(ptr!=NULL){
      id2=ptr->id;
      Z=Z+ ((float)(threadList[id2].WCEC-threadList[id2].exec_cycles)/(float)threadList[id2].canon_freq);
      if(Z>Q)
	break;
      ptr=ptr->next;
      r++;
    }
  }
    
    /* increase the speed of T2,..Tr while reducing the speed of T1 */
  j=2;
  ptr=curPtr;
  while(j<= r+1 && ptr!=NULL ){
    ptr=ptr->next;
    if(ptr==NULL)
      break;

    if(j<r+1)
      req_time=Q-Qact;
    else{
      req_time=Q-Z;
    }
    if( threadList[ptr->id].active ){
      wxj=(float)(threadList[ptr->id].WCEC-threadList[ptr->id].exec_cycles)/(float)threadList[ptr->id].canon_freq;
      Sj=speed_inc(ptr->id, wxj, req_time);
      B=((float)Sj/(float)threadList[ptr->id].canon_freq-1)*wxj;
      threadList[ptr->id].canon_freq=Sj;
    }/* end if(threadList[ptr->id].active ) */
    else {
      /* Tj is completed but is still in the alpha-queue */
      B=(long_t  )min(req_time, ptr->rem);
    }
    Qact+=B;
    j++;

  }/* end while(j<=r) */
  
  /* ????? how to set up S1 ??? */
  speed_reduce(B,threadList[currentThread].canon_freq );

} /* end of aggr_spd_adj function */



void dvs_aydin_agr(long_t  NTA)
{
  long_t  Y;	
  long_t  Z, wx;
  int i;
  int numReady=0;

  mytrace("enter dvs_aydin_agr\n");

  Y=earliness();

  /* One task extension */  
  for (i = 0; i < numThreads-1; i++) {
    if( threadList[i].active)
      numReady++;
  }
  
  gettimeofday(&CurrentTime, NULL);
  CurrentTime_usec = (long_t )CurrentTime.tv_usec + (long_t )1000000*(long_t )CurrentTime.tv_sec;
  wx= (float)(threadList[currentThread].WCEC-threadList[currentThread].exec_cycles)/(float)threadList[currentThread].canon_freq;

  Z=NTA-CurrentTime_usec-wx;

  

  if(numReady==1 && Z>0){
    /* One task extension */
    speed_reduce(Z,system_U);
    mytrace("OTE!\n");
  }
  else if(DVS==DVS_AGR && numReady >1 && Z>0){
    /* AGR algorithm */    
    speed_reduce(Y,threadList[currentThread].canon_freq );
    aggr_spd_adj( NTA, Z);
  }
  else 
    speed_reduce(Y, system_U);

  mytrace("exit dvs_aydin_agr\n");
}





void Scheduler(bool flag, int caller)
{
  int i, j, k;
  long_t  dead_temp;
  long_t  rel_temp;


  pthread_mutex_lock( &mutex_sched );
  in_sched=TRUE;
  pthread_mutex_unlock( &mutex_sched );


  mytrace("enter scheduler()\n");
  alarm(0);

  if(flag==0){
    mytrace( "Scheduler() called by thread %d from yeield()\n",caller);
    if(DVS==DVS_ORG_LA)
      /* update deadline as soon as a job completes. Bad for look-ahead*/
      threadList[currentThread].abs_deadline =  threadList[currentThread].abs_deadline + threadList[currentThread].deadline;
  }
  else if(flag==1){
    /* called from timerhandler */
    mytrace( "Scheduler() called by timerhandler()\n" );
     gettimeofday(&CurrentTime, NULL);
      CurrentTime_usec = (long_t )CurrentTime.tv_usec + (long_t )1000000*(long_t )CurrentTime.tv_sec;
      threadList[currentThread].exec_cycles += ((CurrentTime_usec - threadList[currentThread].start)*(long_t )Frequencies[currentFreqIndex]);
	
	if (DVS==DVS_AGR|| DVS==DVS_OTE){
		updateAlphaQ(&alphaQ, (CurrentTime_usec-last_event_time));
	} 

      mytrace( "Time: %lld, scheduler Interrupting thread %d\n",CurrentTime_usec-StartTime_usec,currentThread );
	
      if (DVS == DVS_CC)
	{
	  /* Ravi 04/21/2004 */
	  dvs_cc(0,currentThread);
	}

      for (i = 0; i < numThreads-1; i++) {
	if (release_vector[i]) {
	  release_vector[i] = false;
	  if (threadList[i].active) {
	    fprintf(stderr,"Time: %0f, %d MISSED DEADLINE",(double)CurrentTime_usec-StartTime_usec, i);
	    //assert (0);
	  }
	  threadList[i].active = true;
	  if(DVS!=DVS_ORG_LA)
	    threadList[i].abs_deadline =  threadList[i].abs_deadline + threadList[i].deadline;
	  threadList[i].release =  threadList[i].next_release;
	  threadList[i].next_release =  threadList[i].next_release +threadList[i].period ;	  	  
	  threadList[i].exec_cycles  = 0;

	  if(DVS==DVS_AGR || DVS==DVS_OTE){
	    push2AlphaQ(&alphaQ, i, threadList[i].release, threadList[i].abs_deadline, (long_t )((float)threadList[i].WCEC/(float)canon_freq));
	  }

	  mytrace("\n*******\n Time: %0f, %d Released\n*******\n",(double)CurrentTime_usec-StartTime_usec, i);

	}
      }
  }else if (flag==2 && (DVS==DVS_AGR || DVS==DVS_OTE) ){ 
    for(i=0;i<numThreads-1;i++){
      push2AlphaQ(&alphaQ, i, threadList[i].release, threadList[i].abs_deadline, (long_t )((float)threadList[i].WCEC/(float)canon_freq));
    }
    
  }

  
  if(DVS==DVS_AGR || DVS==DVS_OTE){
    //dumpAlphaQ(&alphaQ);
  }

  /* stop scheduling after n hyperPeriod */
  gettimeofday(&CurrentTime, NULL);
  CurrentTime_usec = (long_t )CurrentTime.tv_usec + (long_t )1000000*(long_t )CurrentTime.tv_sec;
  if(CurrentTime_usec- StartTime_usec >= hyperP){
    /* stop signal */
    /* set voltage = 1500mV.
     * Note: 1500mV is only used
     * to signal the start/end 
     * of system execution. It is
     * not used during scheduling. 
     */  
#ifdef SYNC      
    my_set_freq("200/100/24");      
#else
    my_set_freq(100);      
#endif
    for (i=0;i<255;i++){
      for(j=0;j<500;j++){
	k=k*2;
      }}
    
    printf("Program stops at time :%.4fsec, expected end time=%.4f\n", (float)(CurrentTime_usec- StartTime_usec)/1000000.0, (float)hyperP/1000000.0); 
#ifdef FD_TEST
    printf("fd_overhead=%f\n", (float)schd_overhead/(float)schd_num);
#endif
    fflush(NULL);
    exit(0);
  }


  if (DVS == DVS_LA || DVS==DVS_ORG_LA) {
    dvs_la();
  } 



  if((DVS==DVS_ST || DVS==DVS_FIXED || DVS==DVS_CC) && (currentThread == numThreads-1))
    {

      if(currentFreqIndex<0 || currentFreqIndex > MAX_FREQ_INDEX ){
	printf("Error at scheduler(): currentFreqIndex =%d\n", currentFreqIndex);
	exit(-1);
      }

#ifdef SYNC
      my_set_freq(FREQ_POINTS[currentFreqIndex]);
#else
      my_set_freq(currentFreqIndex);
#endif
    

    }
#ifdef ST_TEST
  printf("ST_TEST: get ovt1\n");
  gettimeofday(&ovt1, NULL);
#endif


  tmpCurrentThread = -1;
  dead_temp = 0;
  rel_temp =  threadList[0].next_release;
  gettimeofday(&CurrentTime, NULL);
  CurrentTime_usec = (long_t )CurrentTime.tv_usec + (long_t )1000000*(long_t )CurrentTime.tv_sec;


  
  mytrace(" \nCurT- StartTime =%lld \n",CurrentTime_usec- StartTime_usec); 


  for (i =0 ; i < numThreads-1; i++)
    {
      if (threadList[i].active){

	if( dead_temp==0 ){
	  dead_temp=threadList[i].abs_deadline;
	  tmpCurrentThread = i;
	}else{
	  /*dead_temp !=0 */
	  if (threadList[i].abs_deadline < dead_temp)
	    {
	      dead_temp = threadList[i].abs_deadline;
	      tmpCurrentThread = i;
	    }
	}

      }


      
      if (threadList[i].next_release < rel_temp)
	{
	  rel_temp = threadList[i].next_release;
	}

    }

  for (i = 0; i < numThreads-1; i++)
    {
      if (threadList[i].next_release == rel_temp)
	release_vector[i]= true;
    }




  if(CurrentTime_usec > rel_temp)
    {
      /*--scheduling overhead under-estimated!! 
	It seems the only way to avoid this error
	is to reduce scheduling overhead, remove 
	unnecessary debugging statements, or 
	increse threads' WCET and period.
	--*/
      mytrace("Scheduler():  scheduler running behind! current: %lld, next release: %lld, StartTime: %lld\n",CurrentTime_usec-StartTime_usec, rel_temp-StartTime_usec, StartTime_usec);
      
      /* if this time is set too short, the timer interrupt
	 would happen inside scheduler(), and
	 causes race conditions!
      */
      Timer_usec = DELAY_USEC;

    }

  else
    Timer_usec = rel_temp - CurrentTime_usec;

  /*-- original start time setting --
    if(currentThread!=-1){
    threadList[currentThread].start = CurrentTime_usec;
    }
    --*/
  
    
  currentThread=tmpCurrentThread;
  if( (DVS==DVS_AGR||DVS==DVS_OTE) && currentThread!=-1){
  
    dvs_aydin_agr(rel_temp);
  }
 

  if( DVS!=DVS_FD && DVS!=DVS_ORG_FD  && currentThread!=-1 ){
    /* set up next release timer interrupt for non-feedback algorithm*/
    /* for feedback-DVS, this timer will be set in dvs_org_fd() or dvs_fd()*/
    itimer.it_interval.tv_sec = 0;
    itimer.it_interval.tv_usec = 0;
    
    itimer.it_value.tv_sec = 0;
    
    //mytrace("Scheduler(): next timer: %lld\n", rel_temp-StartTime_usec );
    
    while (Timer_usec > 1000000)
      {
	itimer.it_value.tv_sec++;
	Timer_usec -= 1000000;
      }
    
    itimer.it_value.tv_usec = Timer_usec;
    signal(SIGALRM, (void*)timerhandler);
    setitimer(ITIMER_REAL, &itimer, NULL);
  }
   

    
  
  if (DVS==DVS_FD && currentThread!=-1 ){
    /* should be called after the "currentThread" is determined, 
       and after the scheduler timer is set.*/
    dvs_fd(rel_temp);
  }
  
  if (DVS==DVS_ORG_FD && currentThread!=-1 ){
    /* should be called after the "currentThread" is determined, 
       and after the scheduler timer is set.*/
    dvs_org_fd(rel_temp);
  }


  

#ifdef ST_TEST
  gettimeofday(&ovt2,NULL);
  printf("static overhead=%ld\n", ovt2.tv_sec*1000000+ovt2.tv_usec-ovt1.tv_sec*1000000-ovt1.tv_usec);
#endif


  if (currentThread != -1) {
    gettimeofday(&CurrentTime, NULL);
    CurrentTime_usec = (long_t )CurrentTime.tv_usec + (long_t )1000000*(long_t)CurrentTime.tv_sec;
    
    threadList[currentThread].start = CurrentTime_usec;
    mytrace("\n****\nScheduler: dispactching thread %d\n***********\n", currentThread);
    
    mytrace("Leaving scheduler\n");
   
    /* turn on insched==TRUE flag only after siglongjmp completed, in the body of timerhandler() */
    siglongjmp( threadList[ currentThread ].context, 1 );
  }
  else  {
    
    /* currentThread==-1, Idle task */
    if(DVS==DVS_LA || DVS==DVS_ORG_LA){
      currentFreqIndex==0;
    }
    else {
      /* Don't set currentFreqIndex here !!*/
      
	if( DVS==DVS_FD || DVS==DVS_ORG_FD || DVS==DVS_AGR || DVS==DVS_OTE){
	  if(currentFreqIndex!=0){
	    currentFreqIndex=0;
	    
#ifdef SYNC
	    my_set_freq(FREQ_POINTS[0]);
#else
	    my_set_freq(0);
#endif
	  }
	}
	else {
#ifdef SYNC
	  my_set_freq(FREQ_POINTS[0]);
#else
	  my_set_freq(0);
#endif
	  
	}
	  
    }
    /* setting lowest frequenct point for idle */
    currentThread = numThreads-1;
    
    
    /* set up next release timer */
    itimer.it_interval.tv_sec = 0;
    itimer.it_interval.tv_usec = 0;    
    itimer.it_value.tv_sec = 0;
    while (Timer_usec > 1000000)
      {
	itimer.it_value.tv_sec++;
	Timer_usec -= 1000000;
      }
    
    itimer.it_value.tv_usec = Timer_usec;
    signal(SIGALRM, (void*)timerhandler);
    setitimer(ITIMER_REAL, &itimer, NULL);
    
    mytrace( "Scheduler(): going into idle task\n");
    
    pthread_mutex_lock( &mutex_sched );
    in_sched=FALSE;
    pthread_mutex_unlock( &mutex_sched);
    
    /* Note!!! if timer interrupt happens at this time, race condition still exists!!*/
    siglongjmp( threadList[numThreads-1].context, 1 );
  }
  
}



void tmphdl(void)
{
  return;
}





void Start(void)
{

  struct timeval itm1, itm2;
  int i;


#if 0
  /* SYN. vs. ASYN switching overhead measurement */
#ifdef SYNC
  my_set_freq("33/33/16");
  signal(SIGUSR1, (void*)tmphdl);
  gettimeofday( &itm1, NULL);
  kill(getpid(),SIGUSR1);
  gettimeofday( &itm2, NULL);
  printf("signal+syscall time=%f\n", (float)(itm2.tv_sec*1000000+itm2.tv_usec-itm1.tv_sec*1000000-itm1.tv_usec)/1000.0);
  exit(0);





  my_set_freq("266/133/16");
  gettimeofday( &itm1, NULL);
  for(i=0;i<500;i++){
    my_set_freq("33/33/16");
    my_set_freq("266/133/16");
  }
  gettimeofday(&itm2,NULL);
  printf("time=%f\n", (float)(itm2.tv_sec*1000000+itm2.tv_usec-itm1.tv_sec*1000000-itm1.tv_usec)/1000.0);
  exit(0);
#else
  my_set_policy("DVS-533/16");
  my_set_freq(0);	
  signal(SIGUSR1, (void*)tmphdl);
  gettimeofday( &itm1, NULL);
  kill(getpid(),SIGUSR1);
  gettimeofday( &itm2, NULL);
  printf("signal+syscall time=%f\n", (float)(itm2.tv_sec*1000000+itm2.tv_usec-itm1.tv_sec*1000000-itm1.tv_usec)/1000.0);
  exit(0);


  my_set_policy("DVS-533/16");
  my_set_freq(4);
  gettimeofday( &itm1, NULL);
  for(i=0;i<500;i++){
    my_set_freq(1);
    my_set_freq(4);
  }
  gettimeofday(&itm2,NULL);
  printf("time=%f\n", (float)(itm2.tv_sec*1000000+itm2.tv_usec-itm1.tv_sec*1000000-itm1.tv_usec)/1000.0);
  exit(0);


#endif
#endif

	


 
#ifndef SYNC
  my_set_policy("DVS-533/16");
  //my_set_policy("DVS-800/24");
	
#endif
	
  mytrace("Estimated running time: %lld\n", hyperP); 
  
  if( (sortedQ=( int *)malloc(sizeof(int)*(numThreads)))==NULL){
    fprintf(stderr, "Our of memeory inmalloc for sortedQ\n");
    abort();
  }
  for(i=0;i<numThreads;i++){
    sortedQ[i]=i;
  }
	
  mytrace("DVS=%d\n",DVS);
  switch(DVS)
    {
    case DVS_FIXED:
      static_dvs(fixedFreq);
      break;

    case DVS_ST:

      i=alpha2freq(system_U);     
      mytrace("in static dvs %d System U:%lf\n",i,system_U);
      static_dvs(i);
      break;

    case DVS_AGR:
    case DVS_OTE:
      setCanSpeed();
      initAlphaQ(&alphaQ);
      break;

    case DVS_CC:
#ifdef SYNC
      
      my_set_freq("266/133/16");
      currentFreqIndex = MAX_FREQ_INDEX;    
      break;
#else
      //("maxfreqidx=%d\n",MAX_FREQ_INDEX);
      my_set_freq(MAX_FREQ_INDEX);
      currentFreqIndex = MAX_FREQ_INDEX;
      break;
#endif

    case DVS_LA:
    case DVS_ORG_LA:
    case DVS_ORG_FD:
    case DVS_FD:
      currentFreqIndex = MAX_FREQ_INDEX;
    default:
      break;
    }




  pthread_mutex_init(&mutex_sched, NULL);

  if(signal(SIGALRM, (void*)timerhandler)==SIG_ERR){
    perror("Error in registering signal handler\n");
    exit(-1);
  }
 
  Scheduler(2,-1);

 

}


